Index: branches/HM-10.0-dev-SHM/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/App/TAppEncoder/TAppEncTop.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/App/TAppEncoder/TAppEncTop.cpp	(revision 54)
@@ -1,37 +1,37 @@
 /* The copyright in this software is being made available under the BSD
- * License, included below. This software may be subject to other third party
- * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
- *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- *  * Redistributions of source code must retain the above copyright notice,
- *    this list of conditions and the following disclaimer.
- *  * Redistributions in binary form must reproduce the above copyright notice,
- *    this list of conditions and the following disclaimer in the documentation
- *    and/or other materials provided with the distribution.
- *  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
- *    be used to endorse or promote products derived from this software without
- *    specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
- * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
- * THE POSSIBILITY OF SUCH DAMAGE.
- */
+* License, included below. This software may be subject to other third party
+* and contributor rights, including patent rights, and no such rights are
+* granted under this license.  
+*
+* Copyright (c) 2010-2013, ITU/ISO/IEC
+* All rights reserved.
+*
+* Redistribution and use in source and binary forms, with or without
+* modification, are permitted provided that the following conditions are met:
+*
+*  * Redistributions of source code must retain the above copyright notice,
+*    this list of conditions and the following disclaimer.
+*  * Redistributions in binary form must reproduce the above copyright notice,
+*    this list of conditions and the following disclaimer in the documentation
+*    and/or other materials provided with the distribution.
+*  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
+*    be used to endorse or promote products derived from this software without
+*    specific prior written permission.
+*
+* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+* THE POSSIBILITY OF SUCH DAMAGE.
+*/
 
 /** \file     TAppEncTop.cpp
-    \brief    Encoder application class
+\brief    Encoder application class
 */
 
@@ -60,4 +60,10 @@
   m_totalBytes = 0;
   m_essentialBytes = 0;
+#if SVC_EXTENSION
+  for(UInt layer=0; layer < MAX_LAYERS; layer++)
+  {
+    m_apcTEncTop[layer] = &m_acTEncTop[layer];
+  }
+#endif
 }
 
@@ -66,8 +72,301 @@
 }
 
+#if SVC_EXTENSION
 Void TAppEncTop::xInitLibCfg()
 {
+  for(UInt layer=0; layer<m_numLayers; layer++)
+  {
+    TComVPS vps;
+
+    vps.setMaxTLayers                       ( m_maxTempLayer );
+    if (m_maxTempLayer == 1)
+    {
+      vps.setTemporalNestingFlag(true);
+    }
+    vps.setMaxLayers                        ( 1 );
+    for(Int i = 0; i < MAX_TLAYER; i++)
+    {
+      vps.setNumReorderPics                 ( m_numReorderPics[i], i );
+      vps.setMaxDecPicBuffering             ( m_maxDecPicBuffering[i], i );
+    }
+    m_acTEncTop[layer].setVPS(&vps);
+    m_acTEncTop[layer].setFrameRate                    ( m_acLayerCfg[layer].getFrameRate() );
+    m_acTEncTop[layer].setFrameSkip                    ( m_FrameSkip );
+    m_acTEncTop[layer].setSourceWidth                  ( m_acLayerCfg[layer].getSourceWidth() );
+    m_acTEncTop[layer].setSourceHeight                 ( m_acLayerCfg[layer].getSourceHeight() );
+    m_acTEncTop[layer].setConformanceMode              ( m_acLayerCfg[layer].getConformanceMode() );
+    m_acTEncTop[layer].setConformanceWindow            ( m_acLayerCfg[layer].m_confLeft, m_acLayerCfg[layer].m_confRight, m_acLayerCfg[layer].m_confTop, m_acLayerCfg[layer].m_confBottom );
+    m_acTEncTop[layer].setFramesToBeEncoded            ( m_framesToBeEncoded );
+
+    m_acTEncTop[layer].setProfile(m_profile);
+    m_acTEncTop[layer].setLevel(m_levelTier, m_level);
+#if L0046_CONSTRAINT_FLAGS
+    m_acTEncTop[layer].setProgressiveSourceFlag(m_progressiveSourceFlag);
+    m_acTEncTop[layer].setInterlacedSourceFlag(m_interlacedSourceFlag);
+    m_acTEncTop[layer].setNonPackedConstraintFlag(m_nonPackedConstraintFlag);
+    m_acTEncTop[layer].setFrameOnlyConstraintFlag(m_frameOnlyConstraintFlag);
+#endif
+
+#if REF_IDX_MFM
+    if(layer == 0)
+    {
+      m_acTEncTop[layer].setMFMEnabledFlag(false);
+    }
+    else
+    {
+      m_acTEncTop[layer].setMFMEnabledFlag(true);
+    }
+#endif
+    // set layer ID 
+    m_acTEncTop[layer].setLayerId ( layer ); 
+    m_acTEncTop[layer].setNumLayer ( m_numLayers );
+    m_acTEncTop[layer].setLayerEnc(m_apcTEncTop);
+
+    //====== Coding Structure ========
+    m_acTEncTop[layer].setIntraPeriod                  ( m_acLayerCfg[layer].m_iIntraPeriod );
+    m_acTEncTop[layer].setDecodingRefreshType          ( m_iDecodingRefreshType );
+    m_acTEncTop[layer].setGOPSize                      ( m_iGOPSize );
+    m_acTEncTop[layer].setGopList                      ( m_GOPList );
+    m_acTEncTop[layer].setExtraRPSs                    ( m_extraRPSs );
+    for(Int i = 0; i < MAX_TLAYER; i++)
+    {
+      m_acTEncTop[layer].setNumReorderPics             ( m_numReorderPics[i], i );
+      m_acTEncTop[layer].setMaxDecPicBuffering         ( m_maxDecPicBuffering[i], i );
+    }
+    for( UInt uiLoop = 0; uiLoop < MAX_TLAYER; ++uiLoop )
+    {
+      m_acTEncTop[layer].setLambdaModifier( uiLoop, m_adLambdaModifier[ uiLoop ] );
+    }
+    m_acTEncTop[layer].setQP                           ( m_acLayerCfg[layer].getIntQP() );
+
+    m_acTEncTop[layer].setPad                          ( m_acLayerCfg[layer].getPad() );
+
+    m_acTEncTop[layer].setMaxTempLayer                 ( m_maxTempLayer );
+    m_acTEncTop[layer].setUseAMP( m_enableAMP );
+
+    //===== Slice ========
+
+    //====== Loop/Deblock Filter ========
+    m_acTEncTop[layer].setLoopFilterDisable            ( m_bLoopFilterDisable       );
+    m_acTEncTop[layer].setLoopFilterOffsetInPPS        ( m_loopFilterOffsetInPPS );
+    m_acTEncTop[layer].setLoopFilterBetaOffset         ( m_loopFilterBetaOffsetDiv2  );
+    m_acTEncTop[layer].setLoopFilterTcOffset           ( m_loopFilterTcOffsetDiv2    );
+    m_acTEncTop[layer].setDeblockingFilterControlPresent( m_DeblockingFilterControlPresent);
+
+    //====== Motion search ========
+    m_acTEncTop[layer].setFastSearch                   ( m_iFastSearch  );
+    m_acTEncTop[layer].setSearchRange                  ( m_iSearchRange );
+    m_acTEncTop[layer].setBipredSearchRange            ( m_bipredSearchRange );
+
+    //====== Quality control ========
+    m_acTEncTop[layer].setMaxDeltaQP                   ( m_iMaxDeltaQP  );
+    m_acTEncTop[layer].setMaxCuDQPDepth                ( m_iMaxCuDQPDepth  );
+
+    m_acTEncTop[layer].setChromaCbQpOffset             ( m_cbQpOffset     );
+    m_acTEncTop[layer].setChromaCrQpOffset             ( m_crQpOffset  );
+
+#if ADAPTIVE_QP_SELECTION
+    m_acTEncTop[layer].setUseAdaptQpSelect             ( m_bUseAdaptQpSelect   );
+#endif
+
+    Int lowestQP;
+    lowestQP =  - 6*(g_bitDepthY - 8); // XXX: check
+
+    if ((m_iMaxDeltaQP == 0 ) && (m_acLayerCfg[layer].getIntQP() == lowestQP) && (m_useLossless == true))
+    {
+      m_bUseAdaptiveQP = false;
+    }
+    m_acTEncTop[layer].setUseAdaptiveQP                ( m_bUseAdaptiveQP  );
+    m_acTEncTop[layer].setQPAdaptationRange            ( m_iQPAdaptationRange );
+
+    //====== Tool list ========
+    m_acTEncTop[layer].setUseSBACRD                    ( m_bUseSBACRD   );
+    m_acTEncTop[layer].setDeltaQpRD                    ( m_uiDeltaQpRD  );
+    m_acTEncTop[layer].setUseASR                       ( m_bUseASR      );
+    m_acTEncTop[layer].setUseHADME                     ( m_bUseHADME    );
+    m_acTEncTop[layer].setUseLossless                  ( m_useLossless );
+    m_acTEncTop[layer].setUseLComb                     ( m_bUseLComb    );
+    m_acTEncTop[layer].setdQPs                         ( m_acLayerCfg[layer].getdQPs() );
+    m_acTEncTop[layer].setUseRDOQ                      ( m_useRDOQ     );
+    m_acTEncTop[layer].setUseRDOQTS                    ( m_useRDOQTS   );
+#if L0232_RD_PENALTY
+    m_acTEncTop[layer].setRDpenalty                    ( m_rdPenalty );
+#endif
+    m_acTEncTop[layer].setQuadtreeTULog2MaxSize        ( m_uiQuadtreeTULog2MaxSize );
+    m_acTEncTop[layer].setQuadtreeTULog2MinSize        ( m_uiQuadtreeTULog2MinSize );
+    m_acTEncTop[layer].setQuadtreeTUMaxDepthInter      ( m_uiQuadtreeTUMaxDepthInter );
+    m_acTEncTop[layer].setQuadtreeTUMaxDepthIntra      ( m_uiQuadtreeTUMaxDepthIntra );
+    m_acTEncTop[layer].setUseFastEnc                   ( m_bUseFastEnc  );
+    m_acTEncTop[layer].setUseEarlyCU                   ( m_bUseEarlyCU  ); 
+    m_acTEncTop[layer].setUseFastDecisionForMerge      ( m_useFastDecisionForMerge  );
+    m_acTEncTop[layer].setUseCbfFastMode               ( m_bUseCbfFastMode  );
+    m_acTEncTop[layer].setUseEarlySkipDetection        ( m_useEarlySkipDetection );
+
+    m_acTEncTop[layer].setUseTransformSkip             ( m_useTransformSkip      );
+    m_acTEncTop[layer].setUseTransformSkipFast         ( m_useTransformSkipFast  );
+    m_acTEncTop[layer].setUseConstrainedIntraPred      ( m_bUseConstrainedIntraPred );
+    m_acTEncTop[layer].setPCMLog2MinSize               ( m_uiPCMLog2MinSize);
+    m_acTEncTop[layer].setUsePCM                       ( m_usePCM );
+    m_acTEncTop[layer].setPCMLog2MaxSize               ( m_pcmLog2MaxSize);
+    m_acTEncTop[layer].setMaxNumMergeCand              ( m_maxNumMergeCand );
+
+
+    //====== Weighted Prediction ========
+    m_acTEncTop[layer].setUseWP                   ( m_useWeightedPred      );
+    m_acTEncTop[layer].setWPBiPred                ( m_useWeightedBiPred   );
+    //====== Parallel Merge Estimation ========
+    m_acTEncTop[layer].setLog2ParallelMergeLevelMinus2 ( m_log2ParallelMergeLevel - 2 );
+
+    //====== Slice ========
+    m_acTEncTop[layer].setSliceMode               ( m_sliceMode                );
+    m_acTEncTop[layer].setSliceArgument           ( m_sliceArgument            );
+
+    //====== Dependent Slice ========
+    m_acTEncTop[layer].setSliceSegmentMode        ( m_sliceSegmentMode         );
+    m_acTEncTop[layer].setSliceSegmentArgument    ( m_sliceSegmentArgument     );
+    Int iNumPartInCU = 1<<(m_uiMaxCUDepth<<1);
+    if(m_sliceSegmentMode==FIXED_NUMBER_OF_LCU)
+    {
+      m_acTEncTop[layer].setSliceSegmentArgument ( m_sliceSegmentArgument * iNumPartInCU );
+    }
+    if(m_sliceMode==FIXED_NUMBER_OF_LCU)
+    {
+      m_acTEncTop[layer].setSliceArgument ( m_sliceArgument * iNumPartInCU );
+    }
+    if(m_sliceMode==FIXED_NUMBER_OF_TILES)
+    {
+      m_acTEncTop[layer].setSliceArgument ( m_sliceArgument );
+    }
+
+    if(m_sliceMode == 0 )
+    {
+      m_bLFCrossSliceBoundaryFlag = true;
+    }
+    m_acTEncTop[layer].setLFCrossSliceBoundaryFlag( m_bLFCrossSliceBoundaryFlag );
+    m_acTEncTop[layer].setUseSAO ( m_bUseSAO );
+    m_acTEncTop[layer].setMaxNumOffsetsPerPic (m_maxNumOffsetsPerPic);
+
+    m_acTEncTop[layer].setSaoLcuBoundary (m_saoLcuBoundary);
+    m_acTEncTop[layer].setSaoLcuBasedOptimization (m_saoLcuBasedOptimization);
+    m_acTEncTop[layer].setPCMInputBitDepthFlag  ( m_bPCMInputBitDepthFlag); 
+    m_acTEncTop[layer].setPCMFilterDisableFlag  ( m_bPCMFilterDisableFlag); 
+
+    m_acTEncTop[layer].setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
+    m_acTEncTop[layer].setRecoveryPointSEIEnabled( m_recoveryPointSEIEnabled );
+    m_acTEncTop[layer].setBufferingPeriodSEIEnabled( m_bufferingPeriodSEIEnabled );
+    m_acTEncTop[layer].setPictureTimingSEIEnabled( m_pictureTimingSEIEnabled );
+    m_acTEncTop[layer].setFramePackingArrangementSEIEnabled( m_framePackingSEIEnabled );
+    m_acTEncTop[layer].setFramePackingArrangementSEIType( m_framePackingSEIType );
+    m_acTEncTop[layer].setFramePackingArrangementSEIId( m_framePackingSEIId );
+    m_acTEncTop[layer].setFramePackingArrangementSEIQuincunx( m_framePackingSEIQuincunx );
+    m_acTEncTop[layer].setFramePackingArrangementSEIInterpretation( m_framePackingSEIInterpretation );
+    m_acTEncTop[layer].setDisplayOrientationSEIAngle( m_displayOrientationSEIAngle );
+    m_acTEncTop[layer].setTemporalLevel0IndexSEIEnabled( m_temporalLevel0IndexSEIEnabled );
+    m_acTEncTop[layer].setGradualDecodingRefreshInfoEnabled( m_gradualDecodingRefreshInfoEnabled );
+    m_acTEncTop[layer].setDecodingUnitInfoSEIEnabled( m_decodingUnitInfoSEIEnabled );
+    m_acTEncTop[layer].setUniformSpacingIdr          ( m_iUniformSpacingIdr );
+    m_acTEncTop[layer].setNumColumnsMinus1           ( m_iNumColumnsMinus1 );
+    m_acTEncTop[layer].setNumRowsMinus1              ( m_iNumRowsMinus1 );
+    if(m_iUniformSpacingIdr==0)
+    {
+      m_acTEncTop[layer].setColumnWidth              ( m_pColumnWidth );
+      m_acTEncTop[layer].setRowHeight                ( m_pRowHeight );
+    }
+    m_acTEncTop[layer].xCheckGSParameters();
+    Int uiTilesCount          = (m_iNumRowsMinus1+1) * (m_iNumColumnsMinus1+1);
+    if(uiTilesCount == 1)
+    {
+      m_bLFCrossTileBoundaryFlag = true; 
+    }
+    m_acTEncTop[layer].setLFCrossTileBoundaryFlag( m_bLFCrossTileBoundaryFlag );
+    m_acTEncTop[layer].setWaveFrontSynchro           ( m_iWaveFrontSynchro );
+    m_acTEncTop[layer].setWaveFrontSubstreams        ( m_acLayerCfg[layer].m_iWaveFrontSubstreams );
+    m_acTEncTop[layer].setTMVPModeId ( m_TMVPModeId );
+    m_acTEncTop[layer].setUseScalingListId           ( m_useScalingListId  );
+    m_acTEncTop[layer].setScalingListFile            ( m_scalingListFile   );
+    m_acTEncTop[layer].setSignHideFlag(m_signHideFlag);
+#if RATE_CONTROL_LAMBDA_DOMAIN
+    m_acTEncTop[layer].setUseRateCtrl         ( m_RCEnableRateControl );
+    m_acTEncTop[layer].setTargetBitrate       ( m_RCTargetBitrate );
+    m_acTEncTop[layer].setKeepHierBit         ( m_RCKeepHierarchicalBit );
+    m_acTEncTop[layer].setLCULevelRC          ( m_RCLCULevelRC );
+    m_acTEncTop[layer].setUseLCUSeparateModel ( m_RCUseLCUSeparateModel );
+    m_acTEncTop[layer].setInitialQP           ( m_RCInitialQP );
+    m_acTEncTop[layer].setForceIntraQP        ( m_RCForceIntraQP );
+#else
+    m_acTEncTop[layer].setUseRateCtrl     ( m_enableRateCtrl);
+    m_acTEncTop[layer].setTargetBitrate   ( m_targetBitrate);
+    m_acTEncTop[layer].setNumLCUInUnit    ( m_numLCUInUnit);
+#endif
+    m_acTEncTop[layer].setTransquantBypassEnableFlag(m_TransquantBypassEnableFlag);
+    m_acTEncTop[layer].setCUTransquantBypassFlagValue(m_CUTransquantBypassFlagValue);
+    m_acTEncTop[layer].setUseRecalculateQPAccordingToLambda( m_recalculateQPAccordingToLambda );
+    m_acTEncTop[layer].setUseStrongIntraSmoothing( m_useStrongIntraSmoothing );
+    m_acTEncTop[layer].setActiveParameterSetsSEIEnabled ( m_activeParameterSetsSEIEnabled ); 
+    m_acTEncTop[layer].setVuiParametersPresentFlag( m_vuiParametersPresentFlag );
+    m_acTEncTop[layer].setAspectRatioIdc( m_aspectRatioIdc );
+    m_acTEncTop[layer].setSarWidth( m_sarWidth );
+    m_acTEncTop[layer].setSarHeight( m_sarHeight );
+    m_acTEncTop[layer].setOverscanInfoPresentFlag( m_overscanInfoPresentFlag );
+    m_acTEncTop[layer].setOverscanAppropriateFlag( m_overscanAppropriateFlag );
+    m_acTEncTop[layer].setVideoSignalTypePresentFlag( m_videoSignalTypePresentFlag );
+    m_acTEncTop[layer].setVideoFormat( m_videoFormat );
+    m_acTEncTop[layer].setVideoFullRangeFlag( m_videoFullRangeFlag );
+    m_acTEncTop[layer].setColourDescriptionPresentFlag( m_colourDescriptionPresentFlag );
+    m_acTEncTop[layer].setColourPrimaries( m_colourPrimaries );
+    m_acTEncTop[layer].setTransferCharacteristics( m_transferCharacteristics );
+    m_acTEncTop[layer].setMatrixCoefficients( m_matrixCoefficients );
+    m_acTEncTop[layer].setChromaLocInfoPresentFlag( m_chromaLocInfoPresentFlag );
+    m_acTEncTop[layer].setChromaSampleLocTypeTopField( m_chromaSampleLocTypeTopField );
+    m_acTEncTop[layer].setChromaSampleLocTypeBottomField( m_chromaSampleLocTypeBottomField );
+    m_acTEncTop[layer].setNeutralChromaIndicationFlag( m_neutralChromaIndicationFlag );
+    m_acTEncTop[layer].setDefaultDisplayWindow( m_defDispWinLeftOffset, m_defDispWinRightOffset, m_defDispWinTopOffset, m_defDispWinBottomOffset );
+    m_acTEncTop[layer].setFrameFieldInfoPresentFlag( m_frameFieldInfoPresentFlag );
+    m_acTEncTop[layer].setPocProportionalToTimingFlag( m_pocProportionalToTimingFlag );
+    m_acTEncTop[layer].setNumTicksPocDiffOneMinus1   ( m_numTicksPocDiffOneMinus1    );
+    m_acTEncTop[layer].setBitstreamRestrictionFlag( m_bitstreamRestrictionFlag );
+    m_acTEncTop[layer].setTilesFixedStructureFlag( m_tilesFixedStructureFlag );
+    m_acTEncTop[layer].setMotionVectorsOverPicBoundariesFlag( m_motionVectorsOverPicBoundariesFlag );
+    m_acTEncTop[layer].setMinSpatialSegmentationIdc( m_minSpatialSegmentationIdc );
+    m_acTEncTop[layer].setMaxBytesPerPicDenom( m_maxBytesPerPicDenom );
+    m_acTEncTop[layer].setMaxBitsPerMinCuDenom( m_maxBitsPerMinCuDenom );
+    m_acTEncTop[layer].setLog2MaxMvLengthHorizontal( m_log2MaxMvLengthHorizontal );
+    m_acTEncTop[layer].setLog2MaxMvLengthVertical( m_log2MaxMvLengthVertical );
+#if SIGNAL_BITRATE_PICRATE_IN_VPS
+    TComBitRatePicRateInfo *bitRatePicRateInfo = m_cTEncTop[layer].getVPS()->getBitratePicrateInfo();
+    // The number of bit rate/pic rate have to equal to number of sub-layers.
+    if(m_bitRatePicRateMaxTLayers)
+    {
+      assert(m_bitRatePicRateMaxTLayers == m_cTEncTop[layer].getVPS()->getMaxTLayers());
+    }
+    for(Int i = 0; i < m_bitRatePicRateMaxTLayers; i++)
+    {
+      bitRatePicRateInfo->setBitRateInfoPresentFlag( i, m_bitRateInfoPresentFlag[i] );
+      if( bitRatePicRateInfo->getBitRateInfoPresentFlag(i) )
+      {
+        bitRatePicRateInfo->setAvgBitRate(i, m_avgBitRate[i]);
+        bitRatePicRateInfo->setMaxBitRate(i, m_maxBitRate[i]);
+      }
+    }
+    for(Int i = 0; i < m_bitRatePicRateMaxTLayers; i++)
+    {
+      bitRatePicRateInfo->setPicRateInfoPresentFlag( i, m_picRateInfoPresentFlag[i] );
+      if( bitRatePicRateInfo->getPicRateInfoPresentFlag(i) )
+      {
+        bitRatePicRateInfo->setAvgPicRate     (i, m_avgPicRate[i]);
+        bitRatePicRateInfo->setConstantPicRateIdc(i, m_constantPicRateIdc[i]);
+      }
+    }
+#endif
+#if REF_IDX_FRAMEWORK
+    m_acTEncTop[layer].setElRapSliceTypeB(layer == 0? 0 : m_elRapSliceBEnabled);
+#endif
+  }
+}
+#else
+Void TAppEncTop::xInitLibCfg()
+{
   TComVPS vps;
-  
+
   vps.setMaxTLayers                       ( m_maxTempLayer );
   if (m_maxTempLayer == 1)
@@ -91,5 +390,5 @@
   m_cTEncTop.setFrameOnlyConstraintFlag(m_frameOnlyConstraintFlag);
 #endif
-  
+
   m_cTEncTop.setFrameRate                    ( m_iFrameRate );
   m_cTEncTop.setFrameSkip                    ( m_FrameSkip );
@@ -98,5 +397,5 @@
   m_cTEncTop.setConformanceWindow            ( m_confLeft, m_confRight, m_confTop, m_confBottom );
   m_cTEncTop.setFramesToBeEncoded            ( m_framesToBeEncoded );
-  
+
   //====== Coding Structure ========
   m_cTEncTop.setIntraPeriod                  ( m_iIntraPeriod );
@@ -115,12 +414,12 @@
   }
   m_cTEncTop.setQP                           ( m_iQP );
-  
+
   m_cTEncTop.setPad                          ( m_aiPad );
-    
+
   m_cTEncTop.setMaxTempLayer                 ( m_maxTempLayer );
   m_cTEncTop.setUseAMP( m_enableAMP );
-  
+
   //===== Slice ========
-  
+
   //====== Loop/Deblock Filter ========
   m_cTEncTop.setLoopFilterDisable            ( m_bLoopFilterDisable       );
@@ -155,5 +454,5 @@
   m_cTEncTop.setUseAdaptiveQP                ( m_bUseAdaptiveQP  );
   m_cTEncTop.setQPAdaptationRange            ( m_iQPAdaptationRange );
-  
+
   //====== Tool list ========
   m_cTEncTop.setUseSBACRD                    ( m_bUseSBACRD   );
@@ -186,5 +485,5 @@
   m_cTEncTop.setPCMLog2MaxSize               ( m_pcmLog2MaxSize);
   m_cTEncTop.setMaxNumMergeCand              ( m_maxNumMergeCand );
-  
+
 
   //====== Weighted Prediction ========
@@ -214,5 +513,5 @@
     m_cTEncTop.setSliceArgument ( m_sliceArgument );
   }
-  
+
   if(m_sliceMode == 0 )
   {
@@ -336,8 +635,26 @@
 #endif
 }
+#endif
 
 Void TAppEncTop::xCreateLib()
 {
   // Video I/O
+#if SVC_EXTENSION
+  // initialize global variables
+  initROM();
+
+  for(UInt layer=0; layer<m_numLayers; layer++)
+  {
+    m_acTVideoIOYuvInputFile[layer].open( (Char *)m_acLayerCfg[layer].getInputFile().c_str(),  false, m_inputBitDepthY, m_inputBitDepthC, m_internalBitDepthY, m_internalBitDepthC );  // read  mode
+    m_acTVideoIOYuvInputFile[layer].skipFrames(m_FrameSkip, m_acLayerCfg[layer].getSourceWidth() - m_acLayerCfg[layer].getPad()[0], m_acLayerCfg[layer].getSourceHeight() - m_acLayerCfg[layer].getPad()[1]);
+
+    if (!m_acLayerCfg[layer].getReconFile().empty())
+    {
+      m_acTVideoIOYuvReconFile[layer].open((Char *)m_acLayerCfg[layer].getReconFile().c_str(), true, m_outputBitDepthY, m_outputBitDepthC, m_internalBitDepthY, m_internalBitDepthC );  // write mode
+    }
+
+    m_acTEncTop[layer].create();
+  }
+#else
   m_cTVideoIOYuvInputFile.open( m_pchInputFile,     false, m_inputBitDepthY, m_inputBitDepthC, m_internalBitDepthY, m_internalBitDepthC );  // read  mode
   m_cTVideoIOYuvInputFile.skipFrames(m_FrameSkip, m_iSourceWidth - m_aiPad[0], m_iSourceHeight - m_aiPad[1]);
@@ -345,7 +662,8 @@
   if (m_pchReconFile)
     m_cTVideoIOYuvReconFile.open(m_pchReconFile, true, m_outputBitDepthY, m_outputBitDepthC, m_internalBitDepthY, m_internalBitDepthC);  // write mode
-  
+
   // Neo Decoder
   m_cTEncTop.create();
+#endif
 }
 
@@ -353,14 +671,34 @@
 {
   // Video I/O
+#if SVC_EXTENSION
+  // destroy ROM
+  destroyROM();
+
+  for(UInt layer=0; layer<m_numLayers; layer++)
+  {
+    m_acTVideoIOYuvInputFile[layer].close();
+    m_acTVideoIOYuvReconFile[layer].close();
+
+    m_acTEncTop[layer].destroy();
+  }
+#else
   m_cTVideoIOYuvInputFile.close();
   m_cTVideoIOYuvReconFile.close();
-  
+
   // Neo Decoder
   m_cTEncTop.destroy();
+#endif
 }
 
 Void TAppEncTop::xInitLib()
 {
+#if SVC_EXTENSION
+  for(UInt layer=0; layer<m_numLayers; layer++)
+  {
+    m_acTEncTop[layer].init();
+  }
+#else
   m_cTEncTop.init();
+#endif
 }
 
@@ -370,37 +708,235 @@
 
 /**
- - create internal class
- - initialize internal variable
- - until the end of input YUV file, call encoding function in TEncTop class
- - delete allocated buffers
- - destroy internal class
- .
- */
+- create internal class
+- initialize internal variable
+- until the end of input YUV file, call encoding function in TEncTop class
+- delete allocated buffers
+- destroy internal class
+.
+*/
+#if SVC_EXTENSION
 Void TAppEncTop::encode()
 {
-  fstream bitstreamFile(m_pchBitstreamFile, fstream::binary | fstream::out);
+  fstream bitstreamFile(m_pBitstreamFile, fstream::binary | fstream::out);
   if (!bitstreamFile)
   {
-    fprintf(stderr, "\nfailed to open bitstream file `%s' for writing\n", m_pchBitstreamFile);
+    fprintf(stderr, "\nfailed to open bitstream file `%s' for writing\n", m_pBitstreamFile);
     exit(EXIT_FAILURE);
   }
 
-  TComPicYuv*       pcPicYuvOrg = new TComPicYuv;
+  TComPicYuv*       pcPicYuvOrg [MAX_LAYERS];
   TComPicYuv*       pcPicYuvRec = NULL;
-  
+
   // initialize internal class & member variables
   xInitLibCfg();
   xCreateLib();
   xInitLib();
-  
+
+  // main encoder loop
+  Int   iNumEncoded = 0, iTotalNumEncoded = 0;
+  Bool  bEos = false;
+
+  list<AccessUnit> outputAccessUnits; ///< list of access units to write out.  is populated by the encoding process
+
+  for(UInt layer=0; layer<m_numLayers; layer++)
+  {
+    // allocate original YUV buffer
+    pcPicYuvOrg[layer] = new TComPicYuv;
+#if SVC_UPSAMPLING
+    pcPicYuvOrg[layer]->create( m_acLayerCfg[layer].getSourceWidth(), m_acLayerCfg[layer].getSourceHeight(), m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth, NULL );
+#else
+    pcPicYuvOrg->create( m_acLayerCfg[layer].getSourceWidth(), m_acLayerCfg[layer].getSourceHeight(), m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
+#endif
+  }
+
+#if AVC_SYNTAX
+  if( !m_BLSyntaxFile )
+  {
+    printf( "Wrong base layer syntax input file\n" );
+    exit(EXIT_FAILURE);
+  }
+  fstream streamSyntaxFile( m_BLSyntaxFile, fstream::in | fstream::binary );
+  if( !streamSyntaxFile.good() )
+  {
+    printf( "Base layer syntax input reading error\n" );
+    exit(EXIT_FAILURE);
+  }
+  m_acTEncTop[0].setBLSyntaxFile( &streamSyntaxFile );
+#endif
+
+  Bool bFirstFrame = true;
+  while ( !bEos )
+  {
+    // Read enough frames 
+    Bool bFramesReadyToCode = false;
+    while(!bFramesReadyToCode)
+    {
+      for(UInt layer=0; layer<m_numLayers; layer++)
+      {
+        // get buffers
+        xGetBuffer(pcPicYuvRec, layer);
+
+        // read input YUV file
+        m_acTVideoIOYuvInputFile[layer].read( pcPicYuvOrg[layer], m_acLayerCfg[layer].getPad() );
+
+        if(layer == m_numLayers-1)
+        {
+          // increase number of received frames
+          m_iFrameRcvd++;
+          // check end of file
+          bEos = (m_iFrameRcvd == m_framesToBeEncoded);
+        }
+
+        m_acTEncTop[layer].encodePrep( pcPicYuvOrg[layer] );
+      }
+
+      bFramesReadyToCode = !(!bFirstFrame && ( m_acTEncTop[m_numLayers-1].getNumPicRcvd() != m_iGOPSize && m_iGOPSize ) && !bEos );
+    }
+    Bool flush = 0;
+    // if end of file (which is only detected on a read failure) flush the encoder of any queued pictures
+    if (m_acTVideoIOYuvInputFile[m_numLayers-1].isEof())
+    {
+      flush = true;
+      bEos = true;
+      m_iFrameRcvd--;
+      m_acTEncTop[m_numLayers-1].setFramesToBeEncoded(m_iFrameRcvd);
+    }
+
+    // loop through frames in one GOP 
+    for ( UInt iPicIdInGOP=0; iPicIdInGOP < (bFirstFrame? 1:m_iGOPSize); iPicIdInGOP++ )
+    {
+      // layer by layer for each frame
+      for(UInt layer=0; layer<m_numLayers; layer++)
+      {
+        // call encoding function for one frame
+        m_acTEncTop[layer].encode( flush ? 0 : pcPicYuvOrg[layer], m_acListPicYuvRec[layer], outputAccessUnits, iPicIdInGOP );
+      }
+    }
+
+    iTotalNumEncoded = 0;
+    for(UInt layer=0; layer<m_numLayers; layer++)
+    {
+      // write bistream to file if necessary
+      iNumEncoded = m_acTEncTop[layer].getNumPicRcvd();
+      if ( iNumEncoded > 0 )
+      {
+        xWriteRecon(layer, iNumEncoded);
+        iTotalNumEncoded += iNumEncoded;
+      }
+      m_acTEncTop[layer].setNumPicRcvd( 0 );
+    }
+
+    // write bitstream out
+    if(iTotalNumEncoded)
+    {
+      xWriteStream(bitstreamFile, iTotalNumEncoded, outputAccessUnits);
+      outputAccessUnits.clear();
+    }
+
+    // print out summary
+    if (bEos)
+    {
+      printOutSummary();
+    }
+
+    bFirstFrame = false;
+  }
+  // delete original YUV buffer
+  for(UInt layer=0; layer<m_numLayers; layer++)
+  {
+    pcPicYuvOrg[layer]->destroy();
+    delete pcPicYuvOrg[layer];
+    pcPicYuvOrg[layer] = NULL;
+
+    // delete used buffers in encoder class
+    m_acTEncTop[layer].deletePicBuffer();
+  }
+
+#if AVC_SYNTAX
+  if( streamSyntaxFile.is_open() )
+  {
+    streamSyntaxFile.close();
+  }
+#endif
+
+  // delete buffers & classes
+  xDeleteBuffer();
+  xDestroyLib();
+
+  printRateSummary();
+
+  return;
+}
+
+Void TAppEncTop::printOutSummary()
+{
+  UInt layer;
+
+  // set frame rate
+  for(layer = 0; layer < m_numLayers; layer++)
+  {
+    m_gcAnalyzeAll[layer].setFrmRate( m_acLayerCfg[layer].getFrameRate());
+    m_gcAnalyzeI[layer].setFrmRate( m_acLayerCfg[layer].getFrameRate() );
+    m_gcAnalyzeP[layer].setFrmRate( m_acLayerCfg[layer].getFrameRate() );
+    m_gcAnalyzeB[layer].setFrmRate( m_acLayerCfg[layer].getFrameRate() );
+  }
+
+  //-- all
+  printf( "\n\nSUMMARY --------------------------------------------------------\n" );
+  printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
+  for(layer = 0; layer < m_numLayers; layer++)
+  {
+    m_gcAnalyzeAll[layer].printOut('a', layer);
+  }
+
+  printf( "\n\nI Slices--------------------------------------------------------\n" );
+  printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
+  for(layer = 0; layer < m_numLayers; layer++)
+  {
+    m_gcAnalyzeI[layer].printOut('i', layer);
+  }
+
+  printf( "\n\nP Slices--------------------------------------------------------\n" );
+  printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
+  for(layer = 0; layer < m_numLayers; layer++)
+  {
+    m_gcAnalyzeP[layer].printOut('p', layer);
+  }
+
+  printf( "\n\nB Slices--------------------------------------------------------\n" );
+  printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
+  for(layer = 0; layer < m_numLayers; layer++)
+  {
+    m_gcAnalyzeB[layer].printOut('b', layer);
+  }
+}
+
+#else
+Void TAppEncTop::encode()
+{
+  fstream bitstreamFile(m_pchBitstreamFile, fstream::binary | fstream::out);
+  if (!bitstreamFile)
+  {
+    fprintf(stderr, "\nfailed to open bitstream file `%s' for writing\n", m_pchBitstreamFile);
+    exit(EXIT_FAILURE);
+  }
+
+  TComPicYuv*       pcPicYuvOrg = new TComPicYuv;
+  TComPicYuv*       pcPicYuvRec = NULL;
+
+  // initialize internal class & member variables
+  xInitLibCfg();
+  xCreateLib();
+  xInitLib();
+
   // main encoder loop
   Int   iNumEncoded = 0;
   Bool  bEos = false;
-  
+
   list<AccessUnit> outputAccessUnits; ///< list of access units to write out.  is populated by the encoding process
 
   // allocate original YUV buffer
   pcPicYuvOrg->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-  
+
   while ( !bEos )
   {
@@ -410,8 +946,8 @@
     // read input YUV file
     m_cTVideoIOYuvInputFile.read( pcPicYuvOrg, m_aiPad );
-    
+
     // increase number of received frames
     m_iFrameRcvd++;
-    
+
     bEos = (m_iFrameRcvd == m_framesToBeEncoded);
 
